
numSquaresX = 50
numSquaresY = 50
squareSize = 10

function love.load()

	success = love.graphics.setMode( 750, 750, false, false, 0 )

    squaresEffect = love.graphics.newPixelEffect [[
		//extern number time;
		//extern number squareSize;
    	//extern number mouseX;
    	//extern number mouseY;
    	extern number screenX;
    	number squareCoordX;
    	number squareCoordY;
    	number posOnSquareX;
    	number posOnSquareY;
    	number blue;
    	number squareSizeLocal;
    	
        vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
        {
        	squareCoordX = pixel_coords.x/screenX;
        	squareCoordY = pixel_coords.y/screenX;
        	
        	//blue = time + mouseX + mouseY;
        	//squareSize = 1.0;
        	return vec4(pixel_coords.x/screenX, pixel_coords.x/screenX, screenX/screenX, 0.5);
        }
    ]]
    testEffect = love.graphics.newPixelEffect [[
    	
    	extern number time;
    	
    	extern number screenX;
    	extern number screenY;
    	extern number divisions;
    	extern number mouseX;
    	extern number mouseY;
    	vec2 mousePos;
    	vec2 squareCoords;
    	number t=1;
    	number squareNumX;
    	number squareNumY;
    	number squareSize;
    	vec2 relCoords;
    	number gapWidth;
    	number dist;
        vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 coords)
        {
        	relCoords.x = coords.x/screenX;
        	relCoords.y = coords.y/screenY;
        	squareNumX = floor(relCoords.x*divisions)/divisions;
        	squareNumY = floor(relCoords.y*divisions)/divisions;
        	
        	squareSize = screenX/divisions;
        	mousePos = vec2((mouseX-squareSize/2)/screenX,(mouseY-squareSize/2)/screenX);
        	squareCoords = vec2(squareNumX, squareNumY);
        	
        	dist = distance(mousePos, squareCoords);
        	
	        gapWidth = clamp(5*dist,0.1,1.0);
			if (abs(squareNumX-relCoords.x) < sin(time)/10000 + 100/screenX/divisions/gapWidth ||
				abs(squareNumY-relCoords.y) < 100/screenY/divisions/gapWidth ||
				abs(squareNumX+1/divisions-relCoords.x) < 100/screenX/divisions/gapWidth ||
				abs(squareNumY+1/divisions-relCoords.y) < 100/screenY/divisions/gapWidth)
			{
				return vec4(0,0,0,0.0);
			}
			else
			{
				return vec4(1-dist/2,1-dist/2,1.0,1-dist*2/3);
			}
        }
    ]]
    
    love.graphics.setBackgroundColor(0,0,0)
   	
	squareSize = 1/numSquaresX
   	--squaresEffect:send("squareSize", squareSize)
   	numSquaresY = math.floor(numSquaresX/love.graphics.getWidth()*love.graphics.getHeight())
   	
   	testEffect:send("screenX", love.graphics.getWidth())
   	testEffect:send("screenY", love.graphics.getHeight())
   	testEffect:send("divisions", numSquaresX)
   	
end

function love.draw()

    love.graphics.setColor(255,255,255,255)
    love.graphics.setPixelEffect(testEffect)
    love.graphics.rectangle('fill', 20,20, love.graphics.getWidth()-40, love.graphics.getHeight()-40)
    
    love.graphics.setPixelEffect()
    
    love.graphics.setColor(255,0,0,255)
    
    love.graphics.printf("Num of Squares (X): " .. numSquaresX, 10, 20, 200)
    love.graphics.printf("Num of Squares (Y): " .. numSquaresY, 10, 40, 200)
    --love.graphics.printf("Square size (in Pixels): " .. squareSize, 10, 60, 200)
   	testEffect:send("divisions", numSquaresX)
end

local t = 0
function love.update(dt)
    t = t + dt
    testEffect:send("time", t)
   	testEffect:send("mouseX", love.mouse.getX())
   	testEffect:send("mouseY", love.graphics.getWidth() - love.mouse.getY())
end

function clamp(val, min, max)
	return math.min(math.max(val, min), max)
end

function love.mousepressed(x, y, button)
	if button == "wd" then
		numSquaresX = clamp(numSquaresX + 3, 4, love.graphics.getWidth()/6)
	elseif button == "wu" then
		numSquaresX = clamp(numSquaresX - 3, 4, love.graphics.getWidth()/6)
	end
	
	squareSize = 1/numSquaresX
   	--squaresEffect:send("squareSize", squareSize)
   	testEffect:send("divisions", numSquaresX)
   	numSquaresY = math.floor(numSquaresX/love.graphics.getWidth()*love.graphics.getHeight())
end



